/*  XRoar - a Dragon/Tandy Coco emulator
 *  Copyright (C) 2003  Ciaran Anscomb
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <errno.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/stat.h>
#include <SDL/SDL.h>

#include "logging.h"
#include "filer.h"

Uint8 buffer[8];

int main(int argc, char **argv) {
	FILER_FD fd;
	int r, i;
	if (argc < 2) {
		printf("Usage: %s file\n", argv[0]);
		exit(1);
	}
	if (filer_open(argv[1], FILER_READ, &fd) == -1) {
		printf("Couldn't read %s: %s\n", argv[1], filer_error);
		exit(1);
	}
	printf("{");
	while ((r = filer_read(fd, buffer, sizeof(buffer))) > 0) {
		printf("\n\t");
		for (i = 0; i < r; i++)
			printf("0x%02x, ", buffer[i]);
	}
	printf("\n}\n");
	filer_close(fd);
	return 0;
}
