/*  XRoar - a Dragon/Tandy Coco emulator
 *  Copyright (C) 2003  Ciaran Anscomb
 *
 *  See LICENSE for redistribution conditions. */

GPDRAWSURFACE screen[2];
#ifdef DOUBLE_BUFFERED
Uint32 flip;
#endif

void video_init(void) {
	GpGraphicModeSet(VIDEO_BPP, NULL);
	GpLcdSurfaceGet(&screen[0], 0);
#ifdef DOUBLE_BUFFERED
	GpLcdSurfaceGet(&screen[1], 0);
	flip = 1;
#endif
	GpSurfaceSet(&screen[0]);
	GpLcdEnable();
	video_clear_screen(MAPCOLOUR(0,0,0));
	video_fillrect(0,0,320,46,MAPCOLOUR(255,255,255));
}

void video_fillrect(Uint32 x, Uint32 y, Uint32 w, Uint32 h, PIXEL colour) {
	PIXEL *p1 = (PIXEL *)screen[0].ptbuffer + x * 240 + y;
#ifdef DOUBLE_BUFFERED
	PIXEL *p2 = (PIXEL *)screen[1].ptbuffer + x * 240 + y;
#endif
	Uint32 skip = 240 - h;
	Uint32 j;
	for (; w; w--) {
		for (j = h; j; j--) {
			*(p1++) = colour;
#ifdef DOUBLE_BUFFERED
			*(p2++) = colour;
#endif
		}
		p1 += skip;
#ifdef DOUBLE_BUFFERED
		p2 += skip;
#endif
	}
}

void video_blit_bothbufs(Uint32 dest, PIXEL *src, Uint32 width, Uint32 height) {
	PIXEL *p1 = (PIXEL *)screen[0].ptbuffer + dest;
#ifdef DOUBLE_BUFFERED
	PIXEL *p2 = (PIXEL *)screen[1].ptbuffer + dest;
#endif
	Uint32 y;
	for (; width; width--) {
		for (y = height; y; y--) {
#ifdef DOUBLE_BUFFERED
			*(p2++) = *src;
#endif
			*(p1++) = *(src++);
		}
		p1 += (240-height);
#ifdef DOUBLE_BUFFERED
		p2 += (240-height);
#endif
	}
}

void video_blit_bytes(Uint32 dest, PIXEL *src, Uint32 width, Uint32 height) {
	PIXEL *p = VIDEO_SCREENBASE + dest;
	Uint32 y;
	for (; width; width--) {
		for (y = height; y; y--) {
			*(p++) = *(src++);
		}
		p += (240-height);
	}
}
