#include "gpdef.h"
#include "gpstdlib.h"
#include "gpgraphic.h"
#include "gpstdio.h"
#include "gpfont.h"

/*
 * This is now defined in the Makefile
#define BPP_16
#define BPP_8
*/

/*
#define DOUBLE_BUFFERED 1
*/

#ifdef BPP_16
#define VIDEO_BPP GPC_DFLAG_16BPP
#define PIXEL Uint16
#define MAPCOLOUR(r,g,b) ((r & 0xf8) << 8 | (g & 0xf8) << 3 | (b & 0xf8) >> 2)
#define BYTES_PER_COLUMN 480
#define WORDS_PER_COLUMN 120
#endif

#ifdef BPP_8
#define VIDEO_BPP GPC_DFLAG_8BPP
#define PIXEL Uint8
#define MAPCOLOUR(r,g,b) ((r & 0xc0) | (g & 0xe0) >> 2 | (b & 0xe0) >> 5)
#define BYTES_PER_COLUMN 240
#define WORDS_PER_COLUMN 60
#endif

#ifdef DOUBLE_BUFFERED
#define VIDEO_UPDATE GpSurfaceFlip(&screen[flip]); flip ^= 1
#define VIDEO_SCREENBASE ((PIXEL *)screen[flip].ptbuffer)
#define VIDEO_SCREENBASE32 ((Uint32 *)screen[flip].ptbuffer)
#define VIDEO_CURRENTBASE ((PIXEL *)screen[flip^1].ptbuffer)
#define VIDEO_CURRENT_SCREEN (flip ^ 1)
#else
#define VIDEO_UPDATE
#define VIDEO_SCREENBASE ((PIXEL *)screen[0].ptbuffer)
#define VIDEO_SCREENBASE32 ((Uint32 *)screen[0].ptbuffer)
#define VIDEO_CURRENTBASE ((PIXEL *)screen[0].ptbuffer)
#define VIDEO_CURRENT_SCREEN (0)
#endif
#define XSTEP 240
#define VIDEO_SKIPBORDER -61441
#define NEXTLINE -76801
#define VIDEO_TOPLEFT (VIDEO_SCREENBASE + 239)
#define VIDEO_VIEWPORT_XOFFSET (32 * 240)
#define VIDEO_VIEWPORT_YOFFSET (-2)
#define VIDEO_VIEWPORT_TOPLEFT (VIDEO_TOPLEFT + VIDEO_VIEWPORT_XOFFSET + VIDEO_VIEWPORT_YOFFSET)

extern GPDRAWSURFACE screen[2];
#ifdef DOUBLE_BUFFERED
extern Uint32 flip;
#endif
